#ifndef __ClouReaderAPI_H__
#define __ClouReaderAPI_H__

#ifdef DLL_CLREADER_IMPLEMENT
#define DLL_CLREADER_API extern "C" __declspec(dllexport)
#else
#define DLL_CLREADER_API extern "C" __declspec(dllimport)
#endif 

#define CLAPI __stdcall

//ֵ
#define	CL_SUCCESS	0	//ɹ
#define	CL_OTHER	-1	//
#define CL_TIMEOUT	-2	//ʱ
#define CL_PARAM	-3	//
//ֵ>0, Ϊڲ, Эĵ

//,ʹANT_1|ANT_2ANT_1+ANT_2
enum CL_ANT
{//
	ANT_1 = 0x00000001,
	ANT_2 = 0x00000002,
	ANT_3 = 0x00000004,
	ANT_4 = 0x00000008,
	ANT_5 = 0x00000010,
	ANT_6 = 0x00000020,
	ANT_7 = 0x00000040,
	ANT_8 = 0x00000080,
	ANT_9 = 0x00000100,
	ANT_10 = 0x00000200,
	ANT_11 = 0x00000400,
	ANT_12 = 0x00000800,
	ANT_13 = 0x00001000,
	ANT_14 = 0x00002000,
	ANT_15 = 0x00004000,
	ANT_16 = 0x00008000,
	ANT_17 = 0x00010000,
	ANT_18 = 0x00020000,
	ANT_19 = 0x00040000,
	ANT_20 = 0x00080000,
	ANT_21 = 0x00100000,
	ANT_22 = 0x00200000,
	ANT_23 = 0x00400000,
	ANT_24 = 0x00800000,
	ANT_25 = 0x01000000,
	ANT_26 = 0x02000000,
	ANT_27 = 0x04000000,
	ANT_28 = 0x08000000,
	ANT_29 = 0x10000000,
	ANT_30 = 0x20000000,
	ANT_31 = 0x40000000,
	ANT_32 = 0x80000000
};

//ȡʽ
enum CL_READ_TYPE
{
	SINGLE_READ = 0x00,		//ζ
	CONSTANT_READ = 0x01	//
};

//
enum CL_DATA_FIELD
{
	EPC_FIELD = 0x01,	//EPC
	TID_FIELD = 0x02,	//TID
	USER_FIELD = 0x03,	//û
	HOLD_FIELD = 0x04,	//
	TID_USER = 0x05,	//TIDû
	TID_HOLD = 0x06,	//TIDͱ
	USER_HOLD = 0x07,	//ûͱ
	TID_USER_HOLD = 0x08	//TID,ûͱ
};

//ȡıǩ
struct CL_TAG
{
	int TagType;	//0:6C, 1:6B, -1:EPC֪ͨ
	char ReaderName[32];	//д
	int ReaderName_len;		//дƵĳ
	char EPC[1024];	//EPC
	int EPC_len;	//EPCݵĳ
	char TID[1024];	//TID
	int TID_len;	//TIDݵĳ
	char UserData[1024];	//UserData
	int UserData_len;		//UserDataݵĳ
	char PC[10];	//PCֵ
	int PC_len;		//PCֵĳ
	unsigned char ANT_NUM;	//ñǩ
	unsigned char RSSI;	//ǩزǿ
	unsigned char Result;	//ȡepcʱ,ֵʾȡ
	char TagetData[1024];	//
	int TagetData_len;		//ݵĳ
	char ReaderTime[64];	//д
	int ReaderTime_len;		//дƵĳ
};

//նıǩݵĻص
typedef void (CLAPI *CL_CALLBACK)(CL_TAG*);

//APIӿڵĵ
//أһַ
DLL_CLREADER_API char* CLAPI CLTest();

//APIĻص
DLL_CLREADER_API void CLAPI CLTestCallBack(CL_CALLBACK clCall);

//ͨTCPӶд
//connParam Ӳ,Ӳ,ҲǶдıʶ,ʽΪ"ip:˿",:"192.168.1.11:9090"
//clCall صָ,ʵܱǩ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLOpenTcpConnect(char* connParam, CL_CALLBACK clCall);

//ͨӶд
//connParam Ӳ,Ӳ,ҲǶдıʶ,ʽΪ"ip:˿",:"COM1:115200"
//clCall صָ,ʵܱǩ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLOpenSerialConnect(char* connParam, CL_CALLBACK clCall);

//ͨUsbӶд
//connParam дıʶ,Ӳ,ҲǶдıʶ,
//ʽΪ"豸·\\?\hid#vid_2121&pid_8633#6&291716bc&0&0000#{4d1e55b2-f16f-11cf-88cb-001111000030}"
//clCall صָ,ʵܱǩ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLOpenUsbConnect(char* connParam, CL_CALLBACK clCall);

//ֹͣǩ
//connParam дıʶ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLStopRead(char* connParam);

//ȡдϢ
//connParam дıʶ
//ver 汾Ϣ
//model дͺ
//elapse дʱ
DLL_CLREADER_API int CLAPI CLGetReaderInfo(char* connParam, char *ver, char *model, unsigned int *elapse);

//ȡϢ
//connParam дıʶ
//ver 汾Ϣ
DLL_CLREADER_API int CLAPI CLGetBaseBandInfo(char* connParam, char *ver);

//ȡдMAC
//connParam дıʶ
//mac macϢ
DLL_CLREADER_API int CLAPI CLGetReaderMAC(char* connParam, char *mac);

//ȡдSN
//connParam дıʶ
//sn snϢ
DLL_CLREADER_API int CLAPI CLGetReaderSN(char* connParam, char *sn);


//ѯдʱ
//connParam дıʶ
//sec ʱ
//usec ʱ΢
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLGetReaderTime(char* connParam,  unsigned long *sec, unsigned long *usec);

//öдʱ
//connParam дıʶ
//sec ʱ
//usec ʱ΢
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLSetReaderTime(char* connParam,  unsigned long sec, unsigned long usec);

//ѯ߹
//connParam дıʶ
//powerBuf 24ȵint,ɹغд1~24ߵĹ(-1ʾû)
//bufLen powerBufĳ,ӦΪ4
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLGetReaderPower(char* connParam, int* powerBuf, size_t bufLen);

//߹
//connParam дıʶ
//powerBuf 24ȵint,дҪõ1~24ߵĹ(-1ʾöӦ)
//bufLen powerBufĳ,ӦΪ24
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLSetReaderPower(char* connParam, int* powerBuf, size_t bufLen);

//ǩEPC
//connParam дıʶ
//ant Ҫʹõ,鿴ҳCL_ANTĶ
//readType ǩʽ(/),鿴ҳCL_READ_TYPEĶ
//field ѡȡ,鿴ҳCL_DATA_FIELDĶ
//Ϊѡ,京οӿĵ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLReadEPC(char* connParam, CL_ANT ant, CL_READ_TYPE readType,
	CL_DATA_FIELD field=EPC_FIELD, char* pwd=NULL, char* match=NULL, int* startPos=NULL, size_t start_len=0,
	int* readLen=NULL, size_t read_Len=0);

//connParam дıʶ
//ant Ҫʹõ,鿴ҳCL_ANTĶ
//readType ǩʽ(/),鿴ҳCL_READ_TYPEĶ
//field ѡȡ,鿴ҳCL_DATA_FIELDĶ
//Ϊѡ,京οӿĵ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLRead6B(char* connParam, CL_ANT ant, CL_READ_TYPE readType,
	CL_DATA_FIELD field=EPC_FIELD, char* pwd=NULL, char* match=NULL, int* startPos=NULL, size_t start_len=0,
	int* readLen=NULL, size_t read_Len=0);

//дǩEPC
//connParam дıʶ
//ant Ҫʹõ,鿴ҳCL_ANTĶ
//writeField Ҫд,鿴ҳCL_DATA_FIELDĶ
//writeData Ҫд,16ַ,ַȲ4ıĩβ0
//matchField ѡƥָҪдıǩ,鿴ҳCL_DATA_FIELDĶ
//matchData ƥ
//Ϊѡ,京οӿĵ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLWriteEPC(char* connParam, CL_ANT ant, CL_DATA_FIELD writeField, char* writeData, 
	CL_DATA_FIELD matchField=EPC_FIELD, char* matchData=NULL,char* pwd=NULL,
	unsigned short writeStart=0, unsigned short matchStart=0, unsigned char block=0);

//ǩEPC
//connParam дıʶ
//ant Ҫʹõ,鿴ҳCL_ANTĶ
//lockField Ҫ,鿴ҳCL_DATA_FIELDĶ
//lockType 
//matchField ѡƥָҪдıǩ,鿴ҳCL_DATA_FIELDĶ
//matchData ƥ
//Ϊѡ,京οӿĵ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLLockTag(char* connParam, CL_ANT ant, int lockField, int lockType, CL_DATA_FIELD matchField, 
	char* matchData, char* pwd, unsigned short matchStart);

//رնд
//connParam дıʶ
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLCloseConnect(char* connParam);

//رеĶд
//ֵ ɹ򷵻0,鿴ҳķֵ
DLL_CLREADER_API int CLAPI CLCloseAllConnect();

#endif //__ClouReaderAPI_H__